Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -1113,121 +1101,119 @@
   DO k = 3, nl
     DO i = 1, len
-      IF (t(i,k)>263.15) THEN
+      IF (t(i, k)>263.15) THEN
         qi(i, k) = 0.
       ELSE
-        IF (t(i,k)<243.15) THEN
+        IF (t(i, k)<243.15) THEN
           qi(i, k) = clw(i, k)
         ELSE
-          fracg = (263.15-t(i,k))/20
-          qi(i, k) = clw(i, k)*fracg
+          fracg = (263.15 - t(i, k)) / 20
+          qi(i, k) = clw(i, k) * fracg
         END IF
       END IF
-! PRINT*,t(i,k),qi(i,k),'temp,testglace'
-    END DO
-  END DO
-
-
+      ! PRINT*,t(i,k),qi(i,k),'temp,testglace'
+    END DO
+  END DO
 
 END SUBROUTINE icefrac
 
 SUBROUTINE cv3_undilute2(nloc, ncum, nd, iflag, icb, icbs, nk, &
-                         tnk, qnk, gznk, hnk, t, q, qs, gz, &
-                         p, ph, h, tv, lv, lf, pbase, buoybase, plcl, &
-                         inb, tp, tvp, clw, hp, ep, sigp, buoy, &
-                         frac_a, frac_s, qpreca, qta)
+        tnk, qnk, gznk, hnk, t, q, qs, gz, &
+        p, ph, h, tv, lv, lf, pbase, buoybase, plcl, &
+        inb, tp, tvp, clw, hp, ep, sigp, buoy, &
+        frac_a, frac_s, qpreca, qta)
   USE lmdz_print_control, ONLY: prt_level
   USE lmdz_conema3
   USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-! ---------------------------------------------------------------------
-! Purpose:
-! FIND THE REST OF THE LIFTED PARCEL TEMPERATURES
-! &
-! COMPUTE THE PRECIPITATION EFFICIENCIES AND THE
-! FRACTION OF PRECIPITATION FALLING OUTSIDE OF CLOUD
-! &
-! FIND THE LEVEL OF NEUTRAL BUOYANCY
-
-! Main differences convect3/convect4:
-!   - icbs (input) is the first level above LCL (may differ from icb)
-!   - many minor differences in the iterations
-!   - condensed water not removed from tvp in convect3
-!   - vertical profile of buoyancy computed here (use of buoybase)
-!   - the determination of inb is different
-!   - no inb1, ONLY inb in output
-! ---------------------------------------------------------------------
-
-  include "cvthermo.h"
-  include "cv3param.h"
+  ! ---------------------------------------------------------------------
+  ! Purpose:
+  ! FIND THE REST OF THE LIFTED PARCEL TEMPERATURES
+  ! &
+  ! COMPUTE THE PRECIPITATION EFFICIENCIES AND THE
+  ! FRACTION OF PRECIPITATION FALLING OUTSIDE OF CLOUD
+  ! &
+  ! FIND THE LEVEL OF NEUTRAL BUOYANCY
+
+  ! Main differences convect3/convect4:
+  !   - icbs (input) is the first level above LCL (may differ from icb)
+  !   - many minor differences in the iterations
+  !   - condensed water not removed from tvp in convect3
+  !   - vertical profile of buoyancy computed here (use of buoybase)
+  !   - the determination of inb is different
+  !   - no inb1, ONLY inb in output
+  ! ---------------------------------------------------------------------
+
   include "YOMCST2.h"
 
-!inputs:
-  INTEGER, INTENT (IN)                               :: ncum, nd, nloc
-  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, icbs, nk
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, q, qs, gz
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
-  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
-  REAL, DIMENSION (nloc), INTENT (IN)                :: tnk, qnk, gznk
-  REAL, DIMENSION (nloc), INTENT (IN)                :: hnk
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: lv, lf, tv, h
-  REAL, DIMENSION (nloc), INTENT (IN)                :: pbase, buoybase, plcl
-
-!input/outputs:
-  REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: tp, tvp, clw   ! Input for k = 1, icb+1 (computed in cv3_undilute1)
-                                                                       ! Output above
-  INTEGER, DIMENSION (nloc), INTENT (INOUT)          :: iflag
-
-!outputs:
-  INTEGER, DIMENSION (nloc), INTENT (OUT)            :: inb
-  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ep, sigp, hp
-  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: buoy
-  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: frac_a, frac_s
-  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qpreca
-  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qta
-
-!local variables:
+  !inputs:
+  INTEGER, INTENT (IN) :: ncum, nd, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: icb, icbs, nk
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t, q, qs, gz
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: p
+  REAL, DIMENSION (nloc, nd + 1), INTENT (IN) :: ph
+  REAL, DIMENSION (nloc), INTENT (IN) :: tnk, qnk, gznk
+  REAL, DIMENSION (nloc), INTENT (IN) :: hnk
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: lv, lf, tv, h
+  REAL, DIMENSION (nloc), INTENT (IN) :: pbase, buoybase, plcl
+
+  !input/outputs:
+  REAL, DIMENSION (nloc, nd), INTENT (INOUT) :: tp, tvp, clw   ! Input for k = 1, icb+1 (computed in cv3_undilute1)
+  ! Output above
+  INTEGER, DIMENSION (nloc), INTENT (INOUT) :: iflag
+
+  !outputs:
+  INTEGER, DIMENSION (nloc), INTENT (OUT) :: inb
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: ep, sigp, hp
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: buoy
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: frac_a, frac_s
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: qpreca
+  REAL, DIMENSION (nloc, nd), INTENT (OUT) :: qta
+
+  !local variables:
   INTEGER i, j, k
   REAL smallestreal
   REAL tg, qg, dqgdT, ahg, alv, alf, s, tc, es, esi, denom, rg, tca, elacrit
-  REAL                                               :: phinu2p
-  REAL                                               :: qhthreshold
-  REAL                                               :: als
-  REAL                                               :: qsat_new, snew
-  REAL, DIMENSION (nloc,nd)                          :: qi
-  REAL, DIMENSION (nloc,nd)                          :: ha    ! moist static energy of adiabatic ascents 
-                                                              ! taking into account precip ejection
-  REAL, DIMENSION (nloc,nd)                          :: hla   ! liquid water static energy of adiabatic ascents 
-                                                              ! taking into account precip ejection
-  REAL, DIMENSION (nloc,nd)                          :: qcld  ! specific cloud water
-  REAL, DIMENSION (nloc,nd)                          :: qhsat    ! specific humidity at saturation
-  REAL, DIMENSION (nloc,nd)                          :: dqhsatdT ! dqhsat/dT
-  REAL, DIMENSION (nloc,nd)                          :: frac  ! ice fraction function of envt temperature
-  REAL, DIMENSION (nloc,nd)                          :: qps   ! specific solid precipitation
-  REAL, DIMENSION (nloc,nd)                          :: qpl   ! specific liquid precipitation
-  REAL, DIMENSION (nloc)                             :: ah0, cape, capem, byp
-  LOGICAL, DIMENSION (nloc)                          :: lcape
-  INTEGER, DIMENSION (nloc)                          :: iposit
-  REAL                                               :: denomm1
-  REAL                                               :: by, defrac, pden, tbis
-  REAL                                               :: fracg
-  REAL                                               :: deltap
-  REAL, SAVE                                         :: Tx, Tm
+  REAL :: phinu2p
+  REAL :: qhthreshold
+  REAL :: als
+  REAL :: qsat_new, snew
+  REAL, DIMENSION (nloc, nd) :: qi
+  REAL, DIMENSION (nloc, nd) :: ha    ! moist static energy of adiabatic ascents
+  ! taking into account precip ejection
+  REAL, DIMENSION (nloc, nd) :: hla   ! liquid water static energy of adiabatic ascents
+  ! taking into account precip ejection
+  REAL, DIMENSION (nloc, nd) :: qcld  ! specific cloud water
+  REAL, DIMENSION (nloc, nd) :: qhsat    ! specific humidity at saturation
+  REAL, DIMENSION (nloc, nd) :: dqhsatdT ! dqhsat/dT
+  REAL, DIMENSION (nloc, nd) :: frac  ! ice fraction function of envt temperature
+  REAL, DIMENSION (nloc, nd) :: qps   ! specific solid precipitation
+  REAL, DIMENSION (nloc, nd) :: qpl   ! specific liquid precipitation
+  REAL, DIMENSION (nloc) :: ah0, cape, capem, byp
+  LOGICAL, DIMENSION (nloc) :: lcape
+  INTEGER, DIMENSION (nloc) :: iposit
+  REAL :: denomm1
+  REAL :: by, defrac, pden, tbis
+  REAL :: fracg
+  REAL :: deltap
+  REAL, SAVE :: Tx, Tm
   DATA Tx/263.15/, Tm/243.15/
-!$OMP THREADPRIVATE(Tx, Tm)
-  REAL                                               :: aa, bb, dd, ddelta, discr
-  REAL                                               :: ff, fp
-  REAL                                               :: coefx, coefm, Zx, Zm, Ux, U, Um
+  !$OMP THREADPRIVATE(Tx, Tm)
+  REAL :: aa, bb, dd, ddelta, discr
+  REAL :: ff, fp
+  REAL :: coefx, coefm, Zx, Zm, Ux, U, Um
 
   IF (prt_level >= 10) THEN
-    print *,'cv3_undilute2.0. icvflag_Tpa, t(1,k), q(1,k), qs(1,k) ', &
-                        icvflag_Tpa, (k, t(1,k), q(1,k), qs(1,k), k = 1,nl)
+    print *, 'cv3_undilute2.0. icvflag_Tpa, t(1,k), q(1,k), qs(1,k) ', &
+            icvflag_Tpa, (k, t(1, k), q(1, k), qs(1, k), k = 1, nl)
   ENDIF
-  smallestreal=tiny(smallestreal)
-
-! =====================================================================
-! --- SOME INITIALIZATIONS
-! =====================================================================
+  smallestreal = tiny(smallestreal)
+
+  ! =====================================================================
+  ! --- SOME INITIALIZATIONS
+  ! =====================================================================
 
   DO k = 1, nl
@@ -1238,34 +1224,33 @@
 
 
-! =====================================================================
-! --- FIND THE REST OF THE LIFTED PARCEL TEMPERATURES
-! =====================================================================
-
-! ---       The procedure is to solve the equation.
-!                cp*tp+L*qp+phi=cp*tnk+L*qnk+gznk.
-
-! ***  Calculate certain parcel quantities, including static energy   ***
-
+  ! =====================================================================
+  ! --- FIND THE REST OF THE LIFTED PARCEL TEMPERATURES
+  ! =====================================================================
+
+  ! ---       The procedure is to solve the equation.
+  !                cp*tp+L*qp+phi=cp*tnk+L*qnk+gznk.
+
+  ! ***  Calculate certain parcel quantities, including static energy   ***
 
   DO i = 1, ncum
-    ah0(i) = (cpd*(1.-qnk(i))+cl*qnk(i))*tnk(i)+ & 
-! debug          qnk(i)*(lv0-clmcpv*(tnk(i)-t0))+gznk(i)
-             qnk(i)*(lv0-clmcpv*(tnk(i)-273.15)) + gznk(i)
-  END DO
-
-!  Ice fraction
+    ah0(i) = (cpd * (1. - qnk(i)) + cl * qnk(i)) * tnk(i) + &
+            ! debug          qnk(i)*(lv0-clmcpv*(tnk(i)-t0))+gznk(i)
+            qnk(i) * (lv0 - clmcpv * (tnk(i) - 273.15)) + gznk(i)
+  END DO
+
+  !  Ice fraction
 
   IF (cvflag_ice) THEN
     DO k = minorig, nl
       DO i = 1, ncum
-          frac(i, k) = (Tx - t(i,k))/(Tx - Tm)
-          frac(i, k) = min(max(frac(i,k),0.0), 1.0)
+        frac(i, k) = (Tx - t(i, k)) / (Tx - Tm)
+        frac(i, k) = min(max(frac(i, k), 0.0), 1.0)
       END DO
     END DO
-! Below cloud base, set ice fraction to cloud base value
+    ! Below cloud base, set ice fraction to cloud base value
     DO k = 1, nl
       DO i = 1, ncum
         IF (k<icb(i)) THEN
-          frac(i,k) = frac(i,icb(i))
+          frac(i, k) = frac(i, icb(i))
         END IF
       END DO
@@ -1274,33 +1259,32 @@
     DO k = 1, nl
       DO i = 1, ncum
-          frac(i,k) = 0.
+        frac(i, k) = 0.
       END DO
     END DO
   ENDIF ! (cvflag_ice)
 
-
   DO k = minorig, nl
-    DO i = 1,ncum
-      ha(i,k) = ah0(i)
-      hla(i,k) = hnk(i)
-      qta(i,k) = qnk(i)
-      qpreca(i,k) = 0.
-      frac_a(i,k) = 0.
-      frac_s(i,k) = frac(i,k)
-      qpl(i,k) = 0.
-      qps(i,k) = 0.
-      qhsat(i,k) = qs(i,k)
-      qcld(i,k) = max(qta(i,k)-qhsat(i,k),0.)
-      IF (k <= icb(i)+1) THEN
-        qhsat(i,k) = qnk(i)-clw(i,k)
-        qcld(i,k) = clw(i,k)
-      ENDIF 
+    DO i = 1, ncum
+      ha(i, k) = ah0(i)
+      hla(i, k) = hnk(i)
+      qta(i, k) = qnk(i)
+      qpreca(i, k) = 0.
+      frac_a(i, k) = 0.
+      frac_s(i, k) = frac(i, k)
+      qpl(i, k) = 0.
+      qps(i, k) = 0.
+      qhsat(i, k) = qs(i, k)
+      qcld(i, k) = max(qta(i, k) - qhsat(i, k), 0.)
+      IF (k <= icb(i) + 1) THEN
+        qhsat(i, k) = qnk(i) - clw(i, k)
+        qcld(i, k) = clw(i, k)
+      ENDIF
     ENDDO
   ENDDO
 
-!jyg<
-! =====================================================================
-! --- SET THE THE FRACTION OF PRECIPITATION FALLING OUTSIDE OF CLOUD
-! =====================================================================
+  !jyg<
+  ! =====================================================================
+  ! --- SET THE THE FRACTION OF PRECIPITATION FALLING OUTSIDE OF CLOUD
+  ! =====================================================================
   DO k = 1, nl
     DO i = 1, ncum
@@ -1309,110 +1293,110 @@
     END DO
   END DO
-!>jyg
-
-! ***  Find lifted parcel quantities above cloud base    ***
-
-!----------------------------------------------------------------------------
+  !>jyg
+
+  ! ***  Find lifted parcel quantities above cloud base    ***
+
+  !----------------------------------------------------------------------------
 
   IF (icvflag_Tpa == 2) THEN
 
-!----------------------------------------------------------------------------
+    !----------------------------------------------------------------------------
 
     DO k = minorig + 1, nl
-      DO i = 1,ncum
-        tp(i,k) = t(i,k)
+      DO i = 1, ncum
+        tp(i, k) = t(i, k)
       ENDDO
-!!      alv = lv0 - clmcpv*(t(i,k)-273.15)
-!!      alf = lf0 + clmci*(t(i,k)-273.15)
-!!      als = alf + alv
-      DO j = 1,4
+      !!      alv = lv0 - clmcpv*(t(i,k)-273.15)
+      !!      alf = lf0 + clmci*(t(i,k)-273.15)
+      !!      als = alf + alv
+      DO j = 1, 4
         DO i = 1, ncum
-! ori	    IF(k.ge.(icb(i)+1))THEN
-          IF (k>=(icbs(i)+1)) THEN                                ! convect3
+          ! ori	    IF(k.ge.(icb(i)+1))THEN
+          IF (k>=(icbs(i) + 1)) THEN                                ! convect3
             tg = tp(i, k)
             IF (tg > Tx) THEN
-              es = 6.112*exp(17.67*(tg - 273.15)/(tg + 243.5 - 273.15))
-              qg = eps*es/(p(i,k)-es*(1.-eps))
+              es = 6.112 * exp(17.67 * (tg - 273.15) / (tg + 243.5 - 273.15))
+              qg = eps * es / (p(i, k) - es * (1. - eps))
             ELSE
-              esi = exp(23.33086-(6111.72784/tg)+0.15215*log(tg))
-              qg = eps*esi/(p(i,k)-esi*(1.-eps))
+              esi = exp(23.33086 - (6111.72784 / tg) + 0.15215 * log(tg))
+              qg = eps * esi / (p(i, k) - esi * (1. - eps))
             ENDIF
-! Ice fraction
+            ! Ice fraction
             ff = 0.
-            fp = 1./(Tx - Tm)
+            fp = 1. / (Tx - Tm)
             IF (tg < Tx) THEN
               IF (tg > Tm) THEN
-                ff = (Tx - tg)*fp
+                ff = (Tx - tg) * fp
               ELSE
                 ff = 1.
               ENDIF ! (tg > Tm)
             ENDIF ! (tg < Tx)
-! Intermediate variables
-            aa = cpd + (cl-cpd)*qnk(i) + lv(i,k)*lv(i,k)*qg/(rrv*tg*tg)
-            ahg = (cpd + (cl-cpd)*qnk(i))*tg + lv(i,k)*qg - &
-                  lf(i,k)*ff*(qnk(i) - qg) + gz(i,k)
-            dd = lf(i,k)*lv(i,k)*qg/(rrv*tg*tg)
-            ddelta = lf(i,k)*(qnk(i) - qg)
-            bb = aa + ddelta*fp + dd*fp*(Tx-tg)
-! Compute Zx and Zm
+            ! Intermediate variables
+            aa = cpd + (cl - cpd) * qnk(i) + lv(i, k) * lv(i, k) * qg / (rrv * tg * tg)
+            ahg = (cpd + (cl - cpd) * qnk(i)) * tg + lv(i, k) * qg - &
+                    lf(i, k) * ff * (qnk(i) - qg) + gz(i, k)
+            dd = lf(i, k) * lv(i, k) * qg / (rrv * tg * tg)
+            ddelta = lf(i, k) * (qnk(i) - qg)
+            bb = aa + ddelta * fp + dd * fp * (Tx - tg)
+            ! Compute Zx and Zm
             coefx = aa
             coefm = aa + dd
             IF (tg > Tx) THEN
-              Zx = ahg            + coefx*(Tx - tg)
-              Zm = ahg - ddelta   + coefm*(Tm - tg)
+              Zx = ahg + coefx * (Tx - tg)
+              Zm = ahg - ddelta + coefm * (Tm - tg)
             ELSE
               IF (tg > Tm) THEN
-                Zx = ahg          + (coefx +fp*ddelta)*(Tx - Tg)
-                Zm = ahg          + (coefm +fp*ddelta)*(Tm - Tg)
+                Zx = ahg + (coefx + fp * ddelta) * (Tx - Tg)
+                Zm = ahg + (coefm + fp * ddelta) * (Tm - Tg)
               ELSE
-                Zx = ahg + ddelta + coefx*(Tx - tg)
-                Zm = ahg          + coefm*(Tm - tg)
+                Zx = ahg + ddelta + coefx * (Tx - tg)
+                Zm = ahg + coefm * (Tm - tg)
               ENDIF ! (tg .gt. Tm)
             ENDIF ! (tg .gt. Tx)
-! Compute the masks Um, U, Ux
-            Um = (sign(1., Zm-ah0(i))+1.)/2.
-            Ux = (sign(1., ah0(i)-Zx)+1.)/2.
-            U = (1. - Um)*(1. - Ux)
-! Compute the updated parcell temperature Tp : 3 cases depending on tg value
+            ! Compute the masks Um, U, Ux
+            Um = (sign(1., Zm - ah0(i)) + 1.) / 2.
+            Ux = (sign(1., ah0(i) - Zx) + 1.) / 2.
+            U = (1. - Um) * (1. - Ux)
+            ! Compute the updated parcell temperature Tp : 3 cases depending on tg value
             IF (tg > Tx) THEN
-              discr = bb*bb - 4*dd*fp*(ah0(i) - ahg + ddelta*fp*(Tx-tg))
-              Tp(i,k) = tg + &
-                  Um*  (ah0(i) - ahg + ddelta)           /(aa + dd) + &
-                  U *2*(ah0(i) - ahg + ddelta*fp*(Tx-tg))/(bb + sqrt(discr)) + &
-                  Ux*  (ah0(i) - ahg)                    /aa
+              discr = bb * bb - 4 * dd * fp * (ah0(i) - ahg + ddelta * fp * (Tx - tg))
+              Tp(i, k) = tg + &
+                      Um * (ah0(i) - ahg + ddelta) / (aa + dd) + &
+                      U * 2 * (ah0(i) - ahg + ddelta * fp * (Tx - tg)) / (bb + sqrt(discr)) + &
+                      Ux * (ah0(i) - ahg) / aa
             ELSEIF (tg > Tm) THEN
-              discr = bb*bb - 4*dd*fp*(ah0(i) - ahg)
-              Tp(i,k) = tg + &
-                  Um*  (ah0(i) - ahg + ddelta*fp*(tg-Tm))/(aa + dd) + &
-                  U *2*(ah0(i) - ahg)                    /(bb + sqrt(discr)) + &
-                  Ux*  (ah0(i) - ahg + ddelta*fp*(tg-Tx))/aa
+              discr = bb * bb - 4 * dd * fp * (ah0(i) - ahg)
+              Tp(i, k) = tg + &
+                      Um * (ah0(i) - ahg + ddelta * fp * (tg - Tm)) / (aa + dd) + &
+                      U * 2 * (ah0(i) - ahg) / (bb + sqrt(discr)) + &
+                      Ux * (ah0(i) - ahg + ddelta * fp * (tg - Tx)) / aa
             ELSE
-              discr = bb*bb - 4*dd*fp*(ah0(i) - ahg + ddelta*fp*(Tm-tg))
-              Tp(i,k) = tg + &
-                  Um*  (ah0(i) - ahg)                    /(aa + dd) + &
-                  U *2*(ah0(i) - ahg + ddelta*fp*(Tm-tg))/(bb + sqrt(discr)) + &
-                  Ux*  (ah0(i) - ahg - ddelta)           /aa
+              discr = bb * bb - 4 * dd * fp * (ah0(i) - ahg + ddelta * fp * (Tm - tg))
+              Tp(i, k) = tg + &
+                      Um * (ah0(i) - ahg) / (aa + dd) + &
+                      U * 2 * (ah0(i) - ahg + ddelta * fp * (Tm - tg)) / (bb + sqrt(discr)) + &
+                      Ux * (ah0(i) - ahg - ddelta) / aa
             ENDIF ! (tg .gt. Tx)
 
-!!     print *,' j, k, Um, U, Ux, aa, bb, discr, dd, ddelta ', j, k, Um, U, Ux, aa, bb, discr, dd, ddelta
-!!     print *,' j, k, ah0(i), ahg, tg, qg, tp(i,k), ff ', j, k, ah0(i), ahg, tg, qg, tp(i,k), ff
+            !!     print *,' j, k, Um, U, Ux, aa, bb, discr, dd, ddelta ', j, k, Um, U, Ux, aa, bb, discr, dd, ddelta
+            !!     print *,' j, k, ah0(i), ahg, tg, qg, tp(i,k), ff ', j, k, ah0(i), ahg, tg, qg, tp(i,k), ff
           END IF ! (k>=(icbs(i)+1))
         END DO ! i = 1, ncum
       END DO ! j = 1,4
       DO i = 1, ncum
-        IF (k>=(icbs(i)+1)) THEN                                ! convect3
+        IF (k>=(icbs(i) + 1)) THEN                                ! convect3
           tg = tp(i, k)
           IF (tg > Tx) THEN
-            es = 6.112*exp(17.67*(tg - 273.15)/(tg + 243.5 - 273.15))
-            qg = eps*es/(p(i,k)-es*(1.-eps))
+            es = 6.112 * exp(17.67 * (tg - 273.15) / (tg + 243.5 - 273.15))
+            qg = eps * es / (p(i, k) - es * (1. - eps))
           ELSE
-            esi = exp(23.33086-(6111.72784/tg)+0.15215*log(tg))
-            qg = eps*esi/(p(i,k)-esi*(1.-eps))
+            esi = exp(23.33086 - (6111.72784 / tg) + 0.15215 * log(tg))
+            qg = eps * esi / (p(i, k) - esi * (1. - eps))
           ENDIF
           clw(i, k) = qnk(i) - qg
-          clw(i, k) = max(0.0, clw(i,k))
-          tvp(i, k) = max(0., tp(i,k)*(1.+qg/eps-qnk(i)))
-! PRINT*,tvp(i,k),'tvp'
-          IF (clw(i,k)<1.E-11) THEN
+          clw(i, k) = max(0.0, clw(i, k))
+          tvp(i, k) = max(0., tp(i, k) * (1. + qg / eps - qnk(i)))
+          ! PRINT*,tvp(i,k),'tvp'
+          IF (clw(i, k)<1.E-11) THEN
             tp(i, k) = tv(i, k)
             tvp(i, k) = tv(i, k)
@@ -1421,67 +1405,67 @@
       END DO ! i = 1, ncum
     END DO ! k = minorig + 1, nl
-!----------------------------------------------------------------------------
+    !----------------------------------------------------------------------------
 
   ELSE IF (icvflag_Tpa == 1) THEN  ! (icvflag_Tpa == 2)
 
-!----------------------------------------------------------------------------
+    !----------------------------------------------------------------------------
 
     DO k = minorig + 1, nl
-      DO i = 1,ncum
-        tp(i,k) = t(i,k)
+      DO i = 1, ncum
+        tp(i, k) = t(i, k)
       ENDDO
-!!      alv = lv0 - clmcpv*(t(i,k)-273.15)
-!!      alf = lf0 + clmci*(t(i,k)-273.15)
-!!      als = alf + alv
-      DO j = 1,4
+      !!      alv = lv0 - clmcpv*(t(i,k)-273.15)
+      !!      alf = lf0 + clmci*(t(i,k)-273.15)
+      !!      als = alf + alv
+      DO j = 1, 4
         DO i = 1, ncum
-! ori	    IF(k.ge.(icb(i)+1))THEN
-          IF (k>=(icbs(i)+1)) THEN                                ! convect3
+          ! ori	    IF(k.ge.(icb(i)+1))THEN
+          IF (k>=(icbs(i) + 1)) THEN                                ! convect3
             tg = tp(i, k)
             IF (tg > Tx .OR. .NOT.cvflag_ice) THEN
-              es = 6.112*exp(17.67*(tg - 273.15)/(tg + 243.5 - 273.15))
-              qg = eps*es/(p(i,k)-es*(1.-eps))
-              dqgdT = lv(i,k)*qg/(rrv*tg*tg)
+              es = 6.112 * exp(17.67 * (tg - 273.15) / (tg + 243.5 - 273.15))
+              qg = eps * es / (p(i, k) - es * (1. - eps))
+              dqgdT = lv(i, k) * qg / (rrv * tg * tg)
             ELSE
-              esi = exp(23.33086-(6111.72784/tg)+0.15215*log(tg))
-              qg = eps*esi/(p(i,k)-esi*(1.-eps))
-              dqgdT = (lv(i,k)+lf(i,k))*qg/(rrv*tg*tg)
+              esi = exp(23.33086 - (6111.72784 / tg) + 0.15215 * log(tg))
+              qg = eps * esi / (p(i, k) - esi * (1. - eps))
+              dqgdT = (lv(i, k) + lf(i, k)) * qg / (rrv * tg * tg)
             ENDIF
             IF (qsat_depends_on_qt) THEN
-              dqgdT = dqgdT*(1.-qta(i,k-1))/(1.-qg)**2
-              qg = qg*(1.-qta(i,k-1))/(1.-qg)            
+              dqgdT = dqgdT * (1. - qta(i, k - 1)) / (1. - qg)**2
+              qg = qg * (1. - qta(i, k - 1)) / (1. - qg)
             ENDIF
-            ahg = (cpd + (cl-cpd)*qta(i,k-1))*tg + lv(i,k)*qg - &
-                  lf(i,k)*frac(i,k)*(qta(i,k-1) - qg) + gz(i,k)
-            Tp(i,k) = tg + (ah0(i) - ahg)/ &
-                    (cpd + (cl-cpd)*qta(i,k-1) + (lv(i,k)+frac(i,k)*lf(i,k))*dqgdT)
-!!   print *,'undilute2 iterations k, Tp(i,k), ah0(i), ahg ', &
-!!                                 k, Tp(i,k), ah0(i), ahg
+            ahg = (cpd + (cl - cpd) * qta(i, k - 1)) * tg + lv(i, k) * qg - &
+                    lf(i, k) * frac(i, k) * (qta(i, k - 1) - qg) + gz(i, k)
+            Tp(i, k) = tg + (ah0(i) - ahg) / &
+                    (cpd + (cl - cpd) * qta(i, k - 1) + (lv(i, k) + frac(i, k) * lf(i, k)) * dqgdT)
+            !!   print *,'undilute2 iterations k, Tp(i,k), ah0(i), ahg ', &
+            !!                                 k, Tp(i,k), ah0(i), ahg
           END IF ! (k>=(icbs(i)+1))
         END DO ! i = 1, ncum
       END DO ! j = 1,4
       DO i = 1, ncum
-        IF (k>=(icbs(i)+1)) THEN                                ! convect3
+        IF (k>=(icbs(i) + 1)) THEN                                ! convect3
           tg = tp(i, k)
           IF (tg > Tx .OR. .NOT.cvflag_ice) THEN
-            es = 6.112*exp(17.67*(tg - 273.15)/(tg + 243.5 - 273.15))
-            qg = eps*es/(p(i,k)-es*(1.-eps))
+            es = 6.112 * exp(17.67 * (tg - 273.15) / (tg + 243.5 - 273.15))
+            qg = eps * es / (p(i, k) - es * (1. - eps))
           ELSE
-            esi = exp(23.33086-(6111.72784/tg)+0.15215*log(tg))
-            qg = eps*esi/(p(i,k)-esi*(1.-eps))
+            esi = exp(23.33086 - (6111.72784 / tg) + 0.15215 * log(tg))
+            qg = eps * esi / (p(i, k) - esi * (1. - eps))
           ENDIF
           IF (qsat_depends_on_qt) THEN
-            qg = qg*(1.-qta(i,k-1))/(1.-qg)            
+            qg = qg * (1. - qta(i, k - 1)) / (1. - qg)
           ENDIF
-          qhsat(i,k) = qg
+          qhsat(i, k) = qg
         END IF ! (k>=(icbs(i)+1))
       END DO ! i = 1, ncum
       DO i = 1, ncum
-        IF (k>=(icbs(i)+1)) THEN                                ! convect3
-          clw(i, k) = qta(i,k-1) - qhsat(i,k)
-          clw(i, k) = max(0.0, clw(i,k))
-          tvp(i, k) = max(0., tp(i,k)*(1.+qhsat(i,k)/eps-qta(i,k-1)))
-! PRINT*,tvp(i,k),'tvp'
-          IF (clw(i,k)<1.E-11) THEN
+        IF (k>=(icbs(i) + 1)) THEN                                ! convect3
+          clw(i, k) = qta(i, k - 1) - qhsat(i, k)
+          clw(i, k) = max(0.0, clw(i, k))
+          tvp(i, k) = max(0., tp(i, k) * (1. + qhsat(i, k) / eps - qta(i, k - 1)))
+          ! PRINT*,tvp(i,k),'tvp'
+          IF (clw(i, k)<1.E-11) THEN
             tp(i, k) = tv(i, k)
             tvp(i, k) = tv(i, k)
